import { Subscription } from 'rxjs';
import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { NtUploadControl, NtUploadControlError, NtUploadFile, NtUploadHandler } from '@ng-tangram/components/upload';
import { NtFileIcons } from './file-icons';
export declare class NtFile extends NtUploadFile {
    id: string;
    progress?: number;
    uploader?: Subscription;
}
export declare class NtFileComponent extends NtUploadControl<NtFile> implements OnInit, ControlValueAccessor {
    icons: NtFileIcons;
    private readonly _destroy;
    private _disabled;
    private _required;
    private _autoupload;
    private _value;
    private _maxFiles;
    private _maxSize;
    private _accept;
    files: NtFile[];
    url: string;
    name: string;
    readonly value: NtFile[];
    disabled: boolean;
    required: boolean;
    accept: string | Array<string>;
    maxSize: number;
    maxFiles: number;
    autoupload: boolean;
    fileElement: ElementRef;
    error: EventEmitter<NtUploadControlError>;
    remove: EventEmitter<NtFile>;
    constructor(uploader: NtUploadHandler, ngControl: NgControl, icons: NtFileIcons);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onTriggerClick(): void;
    _fileChanged(): void;
    removeFile(file: NtFile): void;
    setDisabledState(isDisabled: boolean): void;
    setValue(value: NtFile[]): void;
    getFileIcon(file: NtFile): any;
    private _fileTypeValid;
    private _fileSizeValid;
    private _onUploadBegin;
    private _onUploadProgress;
    private _onUploadDone;
}
