import { Subscription } from 'rxjs';
import { ElementRef, EventEmitter, OnInit, TemplateRef } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { NtModal } from '@ng-tangram/components/modal';
import { NtUploadControl, NtUploadControlError, NtUploadFile, NtUploadHandler } from '@ng-tangram/components/upload';
import { NtPictureIcons } from './picture-icons';
/**
 * 压缩图片
 */
export declare function zipImage(file: File, option?: any): Promise<any>;
export declare const NtPictureAccepts: string[];
export declare class NtPictureFile extends NtUploadFile {
    id: string;
    progress?: number;
    uploader?: Subscription;
    thumbnail: string;
}
export declare class NtPictureComponent extends NtUploadControl<NtPictureFile> implements OnInit, ControlValueAccessor {
    private _modal;
    icons: NtPictureIcons;
    private readonly _destroy;
    private _disabled;
    private _readonly;
    private _required;
    private _autoupload;
    private _value;
    private _maxFiles;
    private _maxSize;
    private _accept;
    files: NtPictureFile[];
    url: string;
    name: string;
    type: '' | 'circle' | 'square';
    readonly value: NtPictureFile[];
    disabled: boolean;
    readonly: boolean;
    required: boolean;
    accept: string | Array<string>;
    maxSize: number;
    maxFiles: number;
    autoupload: boolean;
    fileElement: ElementRef;
    previewTemplate: TemplateRef<any>;
    error: EventEmitter<NtUploadControlError>;
    remove: EventEmitter<NtPictureFile>;
    constructor(_modal: NtModal, uploader: NtUploadHandler, ngControl: NgControl, icons: NtPictureIcons);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onTriggerClick(): void;
    _fileChanged(): Promise<void>;
    removeFile(file: NtPictureFile): void;
    preview(file: NtPictureFile): void;
    setDisabledState(isDisabled: boolean): void;
    setValue(value: NtPictureFile[]): void;
    private _fileTypeValid;
    private _fileSizeValid;
    private _onUploadBegin;
    private _onUploadProgress;
    private _onUploadDone;
}
