import { Observable } from 'rxjs';
/**
 * 文件上传请求服务
 */
import { HttpClient, HttpProgressEvent, HttpSentEvent } from '@angular/common/http';
import { InjectionToken } from '@angular/core';
import { NtUploadStatus } from './upload-status';
export interface NtUploadResult<T> {
    status: NtUploadStatus;
    error?: string;
    data?: T;
}
/**
 * 上传进度处理
 */
export interface NtUploadProgressHandler {
    begin?(event: HttpSentEvent): void;
    progress?(event: HttpProgressEvent): void;
    done?(file?: File): void;
}
export interface NtUploadHandler {
    upload<T>(url: string, file: File, filename: string, handler: NtUploadProgressHandler): Observable<NtUploadResult<T>>;
}
export declare class NtFormDataUploadHandler implements NtUploadHandler {
    private _http;
    constructor(_http: HttpClient);
    upload<T>(url: string, file: File, filename: string, handler?: NtUploadProgressHandler): Observable<NtUploadResult<T>>;
    private _progressHandler;
    private _getFormData;
}
export declare const NT_UPLOAD_HANDLER: InjectionToken<NtUploadHandler>;
